import { EventEmitter } from '../../stencil-public-runtime';
import { SelectOption } from "../../models/selectInputConfig";
export declare class UxplSelectInput {
  el: HTMLElement;
  /**
   * fieldId
   */
  fieldId: string;
  /**
   * allow clear
   */
  allowClear: boolean;
  /**
   * dont close dropDown on clear
   */
  noCloseOnClear: boolean;
  /**
   * label
   */
  label: string;
  /**
   * type
   */
  type: string;
  /**
   * Whether multiple selections allowed
   */
  multiple: boolean;
  /**
   * Max height for pop up eg: 150px
   */
  maxHeight: string;
  /**
   * value (id from MenuOption[])
   */
  value: string;
  /**
   * array of ids from MenuOption[]
   */
  values: string[];
  /**
   * options
   */
  options: SelectOption[];
  /**
   * yPosition (above/below)
   */
  yPosition: string;
  /**
   * hint
   */
  hint: string;
  /**
   * selector caption when no value eg: 'Select'
   */
  selectCaption: string;
  /**
   * placeholder
   */
  placeholder: string;
  /**
   * disabled
   */
  disabled: boolean;
  /**
   * allow input
   */
  allowInput: boolean;
  /**
   * allow edit
   */
  allowEdit: boolean;
  /**
   * required
   */
  required: boolean;
  /**
   * required
   */
  valid: boolean;
  /**
   * border
   */
  bordered: boolean;
  /**
   * Value changed
   */
  uxplSelection: EventEmitter<SelectOption[] | SelectOption>;
  /**
   * Value changed
   */
  uxplChanged: EventEmitter<SelectOption[] | SelectOption>;
  /**
   * Input value
   */
  uxplInputChanged: EventEmitter<string>;
  active: boolean;
  watchHandlerOpt(newValue: SelectOption[], oldValue: SelectOption[]): void;
  watchHandlerVal(newValue: string, oldValue: string): void;
  watchHandlerVals(newValues: string[], oldValues: string[]): void;
  textInput: HTMLInputElement;
  private mode;
  optionsInternal: SelectOption[];
  private toggleActive;
  private selected;
  private get selectedValueString();
  emitSelected(): void;
  addEntry(): void;
  setSelected(option: SelectOption, manualChange?: boolean): void;
  private calculateSelectedOptions;
  componentWillLoad(): void;
  handleInput(): void;
  handleKeyDown(e: any): void;
  clearSelection(): void;
  get isInList(): boolean;
  render(): any;
}
